/*  TALK_BUG.P  */


/*
This is a bug which heads towards the food until in the same square,
same square, then grabs it, and then uses it. In doing this, it's like
the bug in VERY_SIMPLE_BUG.P. However, it also can reply to sentences,
and so demonstrates the use of sentence(), say(), and chars_to_items().

It starts by converting the sentence to items, using
chars_to_items(sentence()). The result is assigned to 'sent'. It then
compares this against two lists:
    [ where is the food ? ]
    [ what are you holding ? ]
and, if it is the same as either, gives an appropriate reply, using say().
*/


define start_thinking();
enddefine;


define think() -> action;
    lvars action;
    lvars sent;

    chars_to_items( sentence() ) -> sent;

    if sent = [ where is the food ? ] then
        say( [ the food is ^(smell()) ] )
    elseif sent = [ what are you holding ? ] then
        if inventory() = ` ` then
            say ( [ i am holding nothing ] )
        else
            say( [ i am holding ^(consword(inventory(),1)) ] )
        endif
    endif;

    if inventory() = `+` then
        "use" -> action
    elseif smell() = "here" then
        "grab" -> action
    else
        smell() -> action;
    endif;

enddefine;


define bugdead();
    "rerun"
enddefine;
